// File: ReadDesiredInteger.java
// Test the RandomFileAccess class by allowing the user to specify the
//      integer to read by its position in the file.
//Also permits a relative seek, and overwriting an int in the binary file

// Prepared by Dr. Spiegel

import java.io.*;
import java.util.*;

public class ReadDesiredInteger {

static int ReadInt(BufferedReader Input) throws java.io.IOException
{return(Integer.valueOf(Input.readLine()).intValue());
}

public static void main(String[] args) throws java.io.IOException
{int Value,Position;
 // Associate the disk file with the File object
 File BinaryFile=new File("int.bin");
 // Now, open a stream from the input file; 
 // RandomAccess allows seek; check its spec in API!
 RandomAccessFile BinaryDataFile=
              new RandomAccessFile(BinaryFile,"rw");
 BufferedReader KBD=new BufferedReader(new InputStreamReader(System.in));

 // Find size of binary file; bytes/4
 int intsInBinaryFile=(int)BinaryDataFile.length()/4;  // File Length in int
 System.out.println("Enter Integer in Range 0 to "+((int)intsInBinaryFile-1));
 System.out.print("Signifying the Integer to Read from File. \nTo move n ints relative "
	+"to current position, enter -n.  0 Quits >");
 System.out.flush();
 Position=ReadInt(KBD);
 while (Position!=0) {
  if (Position>0) // Seek is Absolute Offset
    BinaryDataFile.seek(Position*4);
  else 
    // Skip Position ints; beware of EOF; returns actual # bytes skipped
    BinaryDataFile.skipBytes(-4*Position); 
  int value=0;
  try {
   value=BinaryDataFile.readInt();
   System.out.println("Read "+value);
  }
  catch (java.io.IOException EOF) {
   System.out.println("Position "+BinaryDataFile.getFilePointer()/4+" is Out of Range");
  }

  // Increment present int
  System.out.print("Would you like to increment this integer? Y/N >");
  char answer=KBD.readLine().trim().charAt(0);
  if (answer=='Y' || answer=='y') {
    // Go to beginning of this int
    BinaryDataFile.seek(BinaryDataFile.getFilePointer()-4);
    // Write next int to its place
    System.out.println("Writing "+(value+1)+" to position "+BinaryDataFile.getFilePointer()+
					", the "+BinaryDataFile.getFilePointer()/4+"th int");
    BinaryDataFile.writeInt(value+1);
  }   
  System.out.println("\nEnter Integer in Range 0 to "+((int)intsInBinaryFile-1));
  System.out.print("Signifying the Integer to Read from File. \nTo move n ints relative "
	+"to current position, enter -n.  0 Quits >");
  System.out.flush();
  Position=ReadInt(KBD);
 }
}


}

